Attribute VB_Name = "WNet"
Declare Function WNetAddConnection Lib "mpr.dll" Alias "WNetAddConnectionA" (ByVal lpszNetPath As String, ByVal lpszPassword As String, ByVal lpszLocalName As String) As Long
Declare Function WNetAddConnection2 Lib "mpr.dll" Alias "WNetAddConnection2A" (lpNetResource As NETRESOURCE, ByVal lpPassword As String, ByVal lpUserName As String, ByVal dwFlags As Long) As Long
Declare Function WNetCancelConnection Lib "mpr.dll" Alias "WNetCancelConnectionA" (ByVal lpszName As String, ByVal bForce As Long) As Long
Declare Function WNetCancelConnection2 Lib "mpr.dll" Alias "WNetCancelConnection2A" (ByVal lpName As String, ByVal dwFlags As Long, ByVal fForce As Long) As Long
Declare Function WNetConnectionDialog Lib "mpr.dll" (ByVal hwnd As Long, ByVal dwType As Long) As Long
Declare Function WNetDisconnectDialog Lib "mpr.dll" (ByVal hwnd As Long, ByVal dwType As Long) As Long
Declare Function WNetGetUser Lib "mpr" Alias "WNetGetUserA" (ByVal lpName As String, ByVal lpUserName As String, lpnLength As Long) As Long
Declare Function WNetGetLastError Lib "mpr.dll" Alias "WNetGetLastErrorA" (lpError As Long, ByVal lpErrorBuf As String, ByVal nErrorBufSize As Long, ByVal lpNameBuf As String, ByVal nNameBufSize As Long) As Long

Declare Function WNetGetConnection Lib "mpr.dll" Alias "WNetGetConnectionA" (ByVal lpszLocalName As String, ByVal lpszRemoteName As String, cbRemoteName As Long) As Long
Declare Function WNetGetUniversalName Lib "mpr" Alias "WNetGetUniversalNameA" (ByVal lpLocalPath As String, ByVal dwInfoLevel As Long, lpBuffer As Any, lpBufferSize As Long) As Long

Public Const ERROR_SUCCESS = 0&
Public Const ERROR_INVALID_FUNCTION = 1&
Public Const ERROR_ACCESS_DENIED = 5&
Public Const ERROR_OUTOFMEMORY = 14&
Public Const ERROR_ALREADY_CONNECTED = 52&
Public Const ERROR_BAD_NETPATH = 53&
Public Const ERROR_UNSHARED_RESOURCE = 67&
Public Const ERROR_BAD_NET_NAME = 67&
Public Const ERROR_ALREADY_ASSIGNED = 85&
Public Const ERROR_INVALID_PASSWORD = 86&
Public Const ERROR_BUFFER_OVERFLOW = 111&
Public Const ERROR_BAD_PATHNAME = 161&
Public Const ERROR_ALREADY_EXISTS = 183&
Public Const ERROR_NO_RESOURCE_NAME = 487&
Public Const ERROR_CONNECTION_UNAVAIL = 1201&
Public Const ERROR_BAD_PROVIDER = 1204&
Public Const ERROR_BAD_PROFILE = 1206&
Public Const ERROR_EXTENDED_ERROR = 1208&
Public Const ERROR_INVALID_PASSWORDNAME = 1216&
Public Const ERROR_INTERNAL_ERROR = 1359&
Public Const ERROR_INVALID_PRINTER_NAME = 1801&
Public Const ERROR_BAD_USERNAME = 2202&
Public Const ERROR_LOCAL_DRIVE = 2250&

Public Const RESOURCETYPE_ANY = &H0
Public Const RESOURCETYPE_DISK = &H1
Public Const RESOURCETYPE_PRINT = &H2
Public Const RESOURCETYPE_UNKNOWN = &HFFFF

Public Const CONNECT_UPDATE_PROFILE = &H1


Type NETRESOURCE

    lngScope As Long
    lngType As Long
    lngDisplayType As Long
    lngUsage As Long
    strLocalName As String
    strRemoteName As String
    strComment As String
    strProvider As String

End Type
Function ExErrorHandler() As String
Dim strRetVal As String

Dim ExRV As Long
Dim ExEC As Long
Dim ExED As String
Dim ExDS As Long
Dim ExPR As String
Dim ExPS As Long

ExED = Space(256)
ExDS = Len(ExED)
ExPR = Space(30)
ExPS = Len(ExPR)

ExRV = WNetGetLastError(ExEC, ExED, ExDS, ExPR, ExPS)

If ExRV = ERROR_SUCCESS Then
strRetVal = "Extended Error Information" + vbCrLf + vbCrLf
strRetVal = strRetVal + "Error Code: " + CStr(ExEC) + vbCrLf
strRetVal = strRetVal + "Error Description: " + ExED + vbCrLf
strRetVal = strRetVal + "Network Provider: " + ExPR
Else
strRetVal = "Unable To Process Extended Error!"
End If

ExErrorHandler = strRetVal
End Function

Function IsSuccess(ReturnCode As Long, Msg As String) As Boolean
 
   If ReturnCode = ERROR_SUCCESS Then
      IsSuccess = True
   Else
      IsSuccess = False
      Select Case ReturnCode
 
         Case ERROR_INVALID_FUNCTION:
            Msg = "Function is not supported."
         Case ERROR_OUTOFMEMORY:
            Msg = "Out of Memory."
         Case ERROR_BAD_NET_NAME:
            Msg = "Invalid Network Resource Name."
         Case ERROR_NO_RESOURCE_NAME:
            Msg = "Must Enter A Valid Network Resource Name."
         Case ERROR_INVALID_PASSWORD:
            Msg = "The Password was Invalid."
         Case ERROR_ACCESS_DENIED:
            Msg = "A Security Violation Occurred."
         Case ERROR_ALREADY_CONNECTED:
            Msg = "Local Device Already Connected."
         Case ERROR_CONNECTION_UNAVAIL:
            Msg = "The Resource Is Not Shared."
         Case ERROR_ALREADY_ASSIGNED:
            Msg = "Local Drive Identifier Is In Use."
         Case ERROR_BAD_USERNAME:
            Msg = "No Such User."
         Case ERROR_INVALID_PRINTER_NAME:
            Msg = "No Such Printer."
         Case ERROR_LOCAL_DRIVE:
            Msg = "Can't Disconnect Local Drive."
         Case ERROR_INTERNAL_ERROR:
            Msg = "Internal Error!"
            
         Case ERROR_EXTENDED_ERROR:
            Msg = ExErrorHandler()
                    
         Case Else:
            Msg = "Unrecognized Error " + Str$(ReturnCode) + "."
       End Select
   End If
 End Function


